
// WndStarterDlgDlg.cpp : implementation file
//

#include "stdafx.h"
#include "WndStarterDlg.h"
#include "WndStarterDlgDlg.h"
#include "afxdialogex.h"
#include <atlpath.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CWndStarterDlgDlg dialog



CWndStarterDlgDlg::CWndStarterDlgDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CWndStarterDlgDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CWndStarterDlgDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CWndStarterDlgDlg, CDialogEx)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CWndStarterDlgDlg::OnBnClickedOk)
END_MESSAGE_MAP()


// CWndStarterDlgDlg message handlers

BOOL CWndStarterDlgDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CWndStarterDlgDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialogEx::OnPaint();
	}
}

HCURSOR CWndStarterDlgDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CWndStarterDlgDlg::OnBnClickedOk()
{
	BOOL bOk = FALSE;

	CString stExternApp = GetModulePath() + _T("TestdotNETWnd.exe");
	CPath externAppPath(stExternApp);
	if(externAppPath.FileExists())
	{
		STARTUPINFO si;
		PROCESS_INFORMATION pi;
		ZeroMemory(&si, sizeof(si));
		si.cb = sizeof(si);
		ZeroMemory(&pi, sizeof(pi));
		bOk = ::CreateProcess(NULL, (LPTSTR)stExternApp.GetBuffer(), NULL, NULL, FALSE, 0, NULL, NULL, &si, &pi);

		if(!bOk)
		{
			CString stMsg;
			stMsg.Format(_T("CreateProcess failed: %s, Last SystemError: %d"), stExternApp, ::GetLastError());
			AfxMessageBox(stMsg);
		}
		else
		{
			GetDlgItem(IDOK)->EnableWindow(FALSE);
			// Wait for complete
			WaitForSingleObject( pi.hProcess, INFINITE );

			// Close process and thread handles
			CloseHandle( pi.hProcess );
			CloseHandle( pi.hThread );

			::SetForegroundWindow(this->GetSafeHwnd());  // Not gets focus
			::SetActiveWindow(this->GetSafeHwnd());      // Not gets focus
			::SetFocus(this->GetSafeHwnd());
			::ShowWindow(this->GetSafeHwnd(), SW_SHOW);
			::UpdateWindow(this->GetSafeHwnd());

			GetDlgItem(IDOK)->EnableWindow(TRUE);
		}
	}
	else
	{
		CString stMsg;
		stMsg.Format(_T("File not exist: %s"), stExternApp);
		AfxMessageBox(stMsg);
	}
	
}
